"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCodec = exports.setDefaultCodec = exports.registerCodec = void 0;
const json_1 = require("./json");
const raw_1 = require("./raw");
let defaultCodec = 'json';
let defaultSetted = false;
const codecMap = new Map();
const registerCodec = (codec) => {
    codecMap.set(codec.name(), codec);
};
exports.registerCodec = registerCodec;
const setDefaultCodec = (codec) => {
    if (defaultSetted) {
        throw new Error('default codec can only set once');
    }
    defaultCodec = codec;
    defaultSetted = true;
};
exports.setDefaultCodec = setDefaultCodec;
(0, exports.registerCodec)(new raw_1.RawCodec());
(0, exports.registerCodec)(new json_1.JSONCodec());
const getCodec = (name) => {
    if (!name) {
        return codecMap.get(defaultCodec);
    }
    if (!codecMap.has(name)) {
        throw new Error('codec not registered');
    }
    return codecMap.get(name);
};
exports.getCodec = getCodec;
//# sourceMappingURL=store.js.map