import { AsyncReturnType } from './type';
import { RedisCache, Cacher } from './cache';
import { KeyStringer } from './keyStringer';
export interface Node {
    key: string;
    redisCache: RedisCache;
    weight: number;
}
export interface ShardingOption {
    nodes: Node[];
}
export declare class ShardingCache implements Cacher {
    private nodeMap;
    private ring;
    constructor(option: ShardingOption);
    cacheFn<F extends () => Promise<unknown>>(key: string, fn: F, expire: number, codec?: string, thisArg?: ThisParameterType<F>): Promise<AsyncReturnType<F>>;
    cacheWrapper<T extends (...args: any[]) => Promise<any>>(keyPrefix: string, fn: T, expire: number, codec?: string, keyStringer?: KeyStringer, thisArg?: ThisParameterType<T>): T;
    deleteFnCache(keyPrefix: string, args: any[], keyStringer?: KeyStringer): Promise<void>;
    get<T = any>(key: string, codec?: string): Promise<[T, boolean]>;
    set<T = any>(key: string, val: T, expire: number, codec?: string): Promise<void>;
    delete(...keys: string[]): Promise<void>;
    clean(match?: string, count?: number): Promise<void>;
    private pickNode;
}
